<template>
  <div>
    <Drop
      class="flex flex-col justify-center md:pr-2"
      @dragover="handleDragover"
      @drop="deselectItem"
    >
      <DragList
        :items="unselectedItems"
        :group="group"
      />
    </Drop>

    <div class="flex flex-col justify-around items-center md:pl-2">
      <Drop
        class="flex"
        @dragover="handleDragover"
        @drop="selectItem"
      >
        <div class="drop-box">
          <DragList
            :items="selectedItems"
            :group="group"
          />
        </div>
      </Drop>

      <img
        class="h-32 mt-2"
        :src="img"
      >
    </div>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Model, Prop, Watch } from 'vue-property-decorator'

import _ from 'lodash/fp'

import { Drop } from 'vue-drag-drop'
import DragList from '@/components/DragList.vue'

@Component({
  components: {
    DragList,
    Drop
  }
})
export default class DimensionsSelector extends Vue {
  @Prop(String) group
  @Prop(String) img
  @Prop(Array) selectableItems

  @Model('select') selectedItems: string[]

  selectItem ({ item }) {
    this.$emit('select', _.union(this.selectedItems, [item]))
  }

  deselectItem ({ item }) {
    this.$emit('select', _.difference(this.selectedItems, [item]))
  }

  handleDragover (data, event) {
    if (!data || this.group !== data.group) {
      event.dataTransfer.dropEffect = 'none'
    }
  }

  get unselectedItems () {
    return _.difference(this.selectableItems, this.selectedItems)
  }
}
</script>

<style lang="postcss" scoped>
.drop-box {
  @apply bg-green-lighter border rounded p-4;
}
</style>
